<template>
  <div>
    <div class="playTable_body-inner">
      <div
        v-for="(cell, key) in formattedGrid"
        :key="key"
        class="cell">
        <div
          class="playTable_body-item betNumber"
          :ref="'cell'+cell.key"
          :style="calcStyles(cell)"
          :class="getClass(cell.key)">
          <div
            class="betNumber_inner"
            :style="calcInnerStyles(cell)">
            <div
              class="betNumber_inner-helper"
              :style="calcHelperStyles(cell)">
              <span
                :class="cell.key===shadowWinner ? 'betNumber_inner-shadowWin': ''">{{cell.key}}</span>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
  import Ws from '~/services/ws';
  import svgFieldAnimation from './scopeAnimation';
  import {mapState} from 'vuex';

  const calcBackground = (cell, style = 'background') => {
    return cell[style] ? 'background: ' + cell[style] + ';' : '';
  };
  const calcBorder = (cell, style = 'borderColor') => {
    return cell[style] ? 'border-color: ' + cell[style] + ';' : '';
  };
  const calcBorderWidth = (cell, style = 'borderWidth', width) => {
    return !width ? cell[style] ? 'border-width: ' + cell[style] + 'px;' : '' : 'border-width: ' + width + 'px;';
  };
  const calcShadow = (cell, style = 'shadow') => {
    return cell[style] ? 'box-shadow: ' + cell[style] + ';' : '';
  };
  const calcFontColor = (cell, style = 'color') => {
    return cell[style] ? 'color: ' + cell[style] + ';' : '';
  };

  export default {
    name: "grid",
    data() {
      return {
        svg: null
      }
    },
    computed: {
      ...mapState({
        balance: state => state.wallet.balance,
        shadowWinner: state => state.grid.shadowWin,
        isAuth: state => state.user.isAuth,
        gameStarted: state => state.game.started,
        grid: state => state.grid.data,
        currentGame: state => state.game.currentGame,
        max: state => state.game.settings.cap / 24,
        bet: state => state.game.betAmount,
        waitings: state => state.grid.waiting
      }),
      myBets() {
        return this.$store.getters['game/myBets'];
      },
      formattedGrid() {
        const mapper = ['x', 1, 2, 3, 4, 5, 'y', 6, 7, 8, 9, 10, 'z', 11, 12, 13, 14, 15, 0, 'a', 'b', 'c', 'd', 'e'];
        const d = [];
        for (let i = 0; i < 24; i++) {
          d.push({...this.grid[mapper[i]], ...{key: mapper[i]}});
        }
        svgFieldAnimation.drawBorders(d, this.$refs, this.myBets);
        return d;
      }
    },
    methods: {
      calcHelperStyles(cell) {
        let style = '';
        style += calcBackground(cell, 'backgroundInner');
        style += calcFontColor(cell, 'color');
        return style;
      },
      calcInnerStyles(cell) {
        let style = '';
        style += calcBackground(cell, 'gradientInner');
        style += calcShadow(cell, 'shadowInner');
        style += calcFontColor(cell, 'color');
        return style;
      },
      calcStyles(cell) {
        let style = '';
        style += calcBackground(cell);
        style += calcBorder(cell);
        style += calcShadow(cell);
        style += calcBorderWidth(cell);
        return style;
      },
      getClass(key) {
        let type = '';
        if (isNaN(parseInt(key))) {
          type = 'string';
        } else {
          type = 'number';
        }
        this.waitings.includes(key) ? type += ' waiting' : '';
        return type;
      },
    },
    mounted() {
      svgFieldAnimation.init('#grid');
      Ws.on('logstartgame', msg => {
        if (!msg) return;
        return this.$store.dispatch('game/start', msg.payload);
      });
      Ws.on('logbet', msg => {
        //msg.payload.game_id
        const payload = msg.payload;
        //Need to parse to int on backend;
        this.$store.dispatch('grid/setShadowWin', {number: parseInt(msg.payload.current_win)});
        if (localStorage.getItem('accountname') !== payload.player) {
          this.$store.dispatch('game/alienBet', {
            amount: parseFloat(payload.amount),
            number: payload.number,
            multiplier: 15,
            my: false,
            username: payload.player
          });
        }
      });
      Ws.on('logendgame', msg => {
        if (!msg) return;
        //this.$store.dispatch('common/waitingState', false);
        this.$store.dispatch('game/finish', {
          win: parseInt(msg.payload.win),
          hash: msg.payload.house_seed_hash.toLowerCase()
        });
      });
      //const msg = (localStorage.getItem('accountName') || 'No account') + ' - is demo: ' + localStorage.getItem('demo') + '| game: ' + this.currentGame.toString();
    }
  }
</script>
